{Written by Pop AKA Konstantin E. Borisov}
Uses crt, dos;

type sing = array[0..16382] of single;
		 Psing = ^sing;
     poly = record x1, y1, x2, y2, x3, y3: integer;
            end;

var		p: Psing;								{⥫  砫 ꥪ}
      lng: word;							{ 䠩-ꥪ}
			num_f, num_v: integer; 	{⢮ ࠭  設 ᮮ⢥⢥}
      fac, ver: Psing;    		{⥫  砫 ᠭ ࠭  設}
      normals: Psing;          {⥫  ᨢ ஢-ଠ}
			matrix: array[0..8] of single;
      i: integer;
      mode, page: byte;
      buf: ^byte;
			buf_seg, buf_off: word;
{-------  ⥭ ꥪ ------- }
{楤 뤥   뢠 㤠 䠩 fname, 樠-
 ६ p, num_f, num_v, fac, ver. lng }

procedure load(fname: string);
var f: file;
 		rsl: word;
    i: integer;
begin
 assign(f, fname);
 {$I-}
 FileMode := 0;
 reset(f, 1);
 {$I+}
 if IOResult = 0 then lng := FileSize(f)
 else
 begin
  writeln('Can`t find file: ', fname);
  Halt(1);
 end;

 GetMem(p, lng);
 BlockRead(f, p^, lng, rsl);
 if not rsl = lng then
 begin
  writeln('There isn`t enough memory for this programm.');
  Halt(2);
 end;

 num_v := Trunc(p^[0]);
 ver := @(p^[1]);
 num_f := Trunc(p^[num_v*3+1]);
 fac := @(p^[num_v*3+2]);
 Close(f);
end;

{------ 楤  ᮢ 襭 㣮쭨 -------}
procedure DrawTriangle(xa, ya, xb, yb, xc, yc: integer; col: byte);
var i, j, sl, t: integer;
    xs1, xs2: integer;
begin
 if yb<ya then
 begin
  if yb<yc then
  begin
   sl := ya;
   ya := yb;
   yb := sl;
   sl := xa;
   xa := xb;
   xb := sl;
  end
  else
  begin
   sl := ya;
   ya := yc;
   yc := sl;
   sl := xa;
   xa := xc;
   xc := sl;
  end;
 end
 else
 begin
  if ya > yc then
	begin
   sl := ya;
   ya := yc;
   yc := sl;
   sl := xa;
   xa := xc;
   xc := sl;
	end;
 end;
 if yc < yb then
 begin
  sl := yb;
  yb := yc;
  yc := sl;
  sl := xb;
  xb := xc;
  xc := sl;
 end;


 if (NOT (yc = ya)) then
 begin
  for i := ya to yc do
  begin

   xs1 := Round((xa*(yc-ya)+(xc-xa)*(i-ya))/(yc-ya));
   if i < yb then xs2 := Round((xa*(yb-ya)+(xb-xa)*(i-ya))/(yb-ya))
   else
   begin
    if yb = yc then xs2 := xb
    else xs2 := Round((xc*(yb-yc)+(xb-xc)*(i-yc))/(yb-yc));
   end;
   if (xs2 < xs1) then
   begin
    t := xs1;
    xs1 := xs2;
    xs2 := t;
   end;
   for j := xs1 to xs2 do
   begin
    if ((i>0) AND (j>0) AND (i<200) AND (j<320)) then mem[buf_seg:(buf_off+i*320+j){ a000:(i*320+j)}] := col;
   end;
  end;
 end
 else
 begin
  if xa > xb then
  begin
   if xa > xc then
   begin
    if xb > xc then
    begin
     xs1 := xc;
     xs2 := xa;
    end
    else
    begin
    xs1 := xb;
    xs2 := xa;
    end;
   end
   else
   begin
    xs1 := xc;
    xs2 :=xb;
   end;
  end
  else
  begin
   if xa > xc then
   begin
    xs1 := xc;
    xs2 := xb;
   end
   else
   begin
    xs1 := xa;
    xs2 := xb;
   end;
  end;
 end;
 for j := xs2 to xs1 do
 begin
  if ((i>0) AND (j>0) AND (i<200) AND (j<320)) then mem[buf_seg:(buf_off+i*320+j){ a000:(i*320+j)}] := col;
 end;
end;


{------- 㭪  宦 ୮ ந ------- }
{ 㭪 ६  y  z,  १  x. }
procedure multip(y, z, x: Psing );
begin
 x^[0] := y^[1]*z^[2]-y^[2]*z^[1];
 x^[1] := y^[2]*z^[0]-y^[0]*z^[2];
 x^[2] := y^[0]*z^[1]-y^[1]*z^[0];
end;


{------- 㭪  宦 ந  --------}
{x - ,  ।⠢ ᮡ ⮫ न 窨,
 a -   ८ࠧ, १ 頥  x. }
procedure product (x,a: Psing);
var y: array[0..2] of single;
		i, j: integer;
begin
 y[0] := 0;
 y[1] := 0;
 y[2] := 0;
 for i := 0 to 2 do
  for j := 0 to 2 do
  begin
   y[i] := y[i]+a^[j+i*3]*x^[j];
  end;
 for i := 0 to 2 do x^[i]:=y[i];
end;

{-------    x ------- }
function lnt (x: Psing): single;
begin
 lnt := sqrt(x^[0]*x^[0]+x^[1]*x^[1]+x^[2]*x^[2]);
end;

{------- ᮢ -------}
procedure Screen;
var i: integer;
		t: single;
    o: poly;
    col: byte;
begin

 for i := 0 to num_f-1 do
 begin
  o.x1 := Round(ver^[ Round(fac^[i*3])*3]);
  o.y1 := Round(ver^[ Round(fac^[i*3])*3+1]);

  o.x2 := Round(ver^[ Round(fac^[i*3+1])*3]);
  o.y2 := Round(ver^[ Round(fac^[i*3+1])*3+1]);

  o.x3 := Round(ver^[ Round(fac^[i*3+2])*3]);
  o.y3 := Round(ver^[ Round(fac^[i*3+2])*3+1]);

 	t := normals^[i*3+2];


  if t < 0 then
  begin
   col := -trunc(255*t);
   o.x1 := o.x1 + 160;
   o.y1 := -o.y1 + 120;
   o.x2 := o.x2 + 160;
   o.y2 := -o.y2 + 120;
   o.x3 := o.x3 + 160;
   o.y3 := -o.y3 + 120;

  DrawTriangle(o.x1, o.y1, o.x2, o.y2, o.x3, o.y3, col);
  end;
 end;
end;

{-------  ଠ  ࠭ ------}
procedure normal;
var a, b, nrm: array[0..2] of single;
    t: single;
    i, j: integer;
    x1, x2, x3, y1, y2, y3, z1, z2, z3: single;
begin
 for i := 0 to num_f-1 do
 begin
  x1 := ver^[ Round(fac^[i*3])*3];
  y1 := ver^[ Round(fac^[i*3])*3+1];
  z1 := ver^[ Round(fac^[i*3])*3+2];
  x2 := ver^[ Round(fac^[i*3+1])*3];
  y2 := ver^[ Round(fac^[i*3+1])*3+1];
  z2 := ver^[ Round(fac^[i*3+1])*3+2];
  x3 := ver^[ Round(fac^[i*3+2])*3];
  y3 := ver^[ Round(fac^[i*3+2])*3+1];
  z3 := ver^[ Round(fac^[i*3+2])*3+2];
  a[0] := x2-x1;
  a[1] := y2-y1;
  a[2] := z2-z1;
  b[0] := x3-x1;
  b[1] := y3-y1;
  b[2] := z3-z1;
  multip(@a[0], @b[0], @nrm[0]);
  t := lnt(@nrm[0]);
  for j := 0 to 2 do nrm[j] := nrm[j]/t;
  for j := 0 to 2 do normals^[i*3+j] := nrm[j];
 end;
end;

{------- 室    殮 ୮ -------}
procedure SetGrayColors;
var i, t: integer;
begin
 for i := 0 to 255 do
 begin
  t := i div 4 ;
  port[$3c8] := i;
  port[$3c9] := t;
  port[$3c9] := t;
  port[$3c9] := t;
 end;
end;

{------ 樠㥬 䨪 -------}
procedure InitGr;assembler;
asm
 mov ah, 0fh
 int 10h
 mov mode, al
 mov page, bh
 mov ax, 13h
 int 10h

end;

{-------  ࠭  室 ﭨ -------}
procedure CloseGr;assembler;
asm
 xor ah, ah
 mov al, mode;
 int 10h
 mov ah, 5
 mov al, page;
 int 10h
end;

{------- 頥 ࠭ -------}
procedure ClearScr;
var i: integer;
begin
 for i := 0 to 32000 do
 begin
  memw[$a000:i*2] := memw[buf_seg:(buf_off+i*2)];
 end;
 for i := 0 to 32000 do memw[buf_seg:(buf_off+i*2)] := 0;
end;


{------- ந    ८ࠧ -------}
procedure matr;
var a, at, t: array[0..8] of single;
		x, y, z: array[0..2] of single;
    i, j , k: integer;
    lx, ly, lz: single;
begin

 randomize;
 z[0] := random(20);
 z[1] := random(20);
 z[2] := random(20);

 if z[2] = 0 then
 begin
  if z[0] = 0 then
  begin
   y[2] := 0;
   y[1] := 0;
   y[0] := 1;
  end
  else
  begin
   y[2] := 0;
   y[1] := 1;
   y[0] := -z[1]/z[0];
  end;
 end
 else
 begin
  y[0] := 1;
  y[1] := 1;
  y[2] := -(z[0]+z[1])/z[2];
 end;
 multip(@y[0], @z[0], @x[0]);
 lx := lnt(@x[0]);
 ly := lnt(@y[0]);
 lz := lnt(@z[0]);

 for i := 0 to 2 do
 begin
  x[i] := x[i]/lx;
  y[i] := y[i]/ly;
  z[i] := z[i]/lz;
  a[i*3] := x[i];
  a[i*3+1] := y[i];
  a[i*3+2] := z[i];
 end;
 for i := 0 to 2 do
 begin
  for j := 0 to 2 do
  begin
  at[j+i*3] := a[i+j*3];
  end;
 end;

 for i := 0 to 8 do t[i] := 0;

 for j := 0 to 2 do
 begin
  for i := 0 to 2 do
  begin
   for k := 0 to 2 do
   begin
    t[j*3+i] := t[j*3+i]+a[j*3+k]*matrix[k*3+i];
   end;
  end;
 end;
 for i:= 0 to 8 do matrix[i] := t[i];
 for i := 0 to 8 do t[i] := 0;

 for j := 0 to 2 do
 begin
  for i := 0 to 2 do
  begin
   for k := 0 to 2 do
   begin
    t[j*3+i] := t[j*3+i]+matrix[j*3+k]*at[k*3+i];
   end;
  end;
 end;
 for i := 0 to 8 do matrix[i] := t[i];
end;



{------ 稭  䨣 -------}

procedure Start;
var  i, j: integer;

begin
 j := 0;
 while NOT KeyPressed do
 begin
  Inc(j);
  normal;
  if j > 10 then
  begin
	 matr;
   j := 0;
  end;
  while  NOT (port[$3da] AND 8) = 0 do;
  Screen;
  ClearScr;
  delay(30);
  for i := 0 to num_v-1 do
	begin
	 product( @(ver^[i*3]), @matrix[0]);
  end;
 end;
end;



begin
 ClrScr;
 if ParamCount<1 then
 begin
  writeln('This programm requires filename in command line.');
  halt(1);
 end;
 load(ParamStr(1));						{ ꥪ}
 GetMem(buf, 64000);					{뤥    ࠭}
 GetMem(normals, num_f*3*4);  {뤥   ଠ}
 normal;											{ ଠ}

 buf_seg := Seg(buf^);
 buf_off := Ofs(buf^);

 matrix[0] := 0.9961946;
 matrix[1] := 0.0871557;
 matrix[2] := 0;
 matrix[3] :=	-0.0871557;
 matrix[4] := 0.9961946;
 matrix[5] :=	0;
 matrix[6] := 0;
 matrix[7] :=	0;
 matrix[8] := 1;



 InitGr;											{樠஢ 䨪}
 SetGrayColors;
 Start;
 CloseGr;											{ 䨪}
 FreeMem(p, lng);							{᢮ }
 FreeMem(normals, num_f*3*4);
 FreeMem(buf, 64000);
end.
